## Fichier : Q_HumainVsGeneticSelect.py
# Auteur : Jovian Hersemeule

# Permet de lancer un match
# sur un réseau de neurones donné.

from Outils.Moteur_de_jeu import *
from Outils.Moteur_de_jeu.Partie import *

from Outils import IA_MinMax
from Outils.IA_MinMax import *

from ReseauNeurones import *
from ReseauNeurones.cerveau import *

# Deboguage
debug = True

# Préparation
myBrain = Cerveau()
myBrain.charger_structure( "PrimitifEfficace.stc", debug = debug )
myBrain.charger_poids( "PurAleatoireFast2/Generation50/individu0.pds", debug = debug )
#myBrain.charger_poids( "PurAleatoirePrecis1/Generation81/individu0.pds", debug = debug )
myBrain.build_network( debug = debug )
#myBrain.generer_poids( inf = -1.0, debug = debug )

# Match
joueurA = IA_minmax("Genetic:Primitif", myBrain.fct_eval, 1 )
joueurB = Humain("Humain")

Global.partie = Partie(joueurA, joueurB, True, "")

Global.partie.demarrer()
