from Outils.Moteur_de_jeu import *
from Outils.Moteur_de_jeu.Partie import *

from Outils import IA_MinMax
from Outils.IA_MinMax import *

from ReseauNeurones import *
from ReseauNeurones.cerveau import *

# Deboguage
debug = True

# Préparation
myBrain = Cerveau()
myBrain.charger_structure( "PrimitifEfficace.stc", debug = debug )
myBrain.charger_poids( "Primitif/poidsTest.pds", debug = debug )
myBrain.build_network( debug = debug )
#myBrain.generer_poids( inf = -1.0, debug = debug )

# Match
joueurA = Humain("Humain")
joueurB = IA_minmax("Genetic:Primitif", myBrain.fct_eval, 1 )

Global.partie = Partie(joueurA, joueurB, True, "")

Global.partie.demarrer()

    
